(* Angeles Ruiz Muoz ,ordenador: 903 *)



IMPLEMENTATION MODULE LibCine;
FROM IO IMPORT WrStr,RdStr,WrCard,WrLn,RdLn,WrChar,RdChar;
FROM Window IMPORT Clear;
FROM Storage IMPORT ALLOCATE,DEALLOCATE;
FROM Cadenas IMPORT CompararCadenas;
IMPORT FIO;
CONST
  NUMSALAS=5;

TYPE

  TCine=POINTER TO TSala;

  TLista=POINTER TO Reg;


  TPersona=RECORD
              nom:TCadena;
              fila:CARDINAL;
              prim,ult:CARDINAL;
           END;

  Reg=RECORD
         elem:TPersona;
         sig:TLista;
      END;

  TDatosSala=RECORD
               peli:TCadena;
               fila:CARDINAL;
               butacas:CARDINAL;
               reserva:TLista;
             END;

  TSala=ARRAY [1..NUMSALAS] OF TDatosSala;






  PROCEDURE Pausa();
  (** Hace una pausa en la impresion de los datos **)
  VAR
    car:CHAR;
  BEGIN
    WrLn;
    WrStr("Pulse ENTER para continuar.");RdLn;
    car:=RdChar();
  END Pausa;





(***************  Operaciones con listas   ************************)


  PROCEDURE LongitudLista(lista:TLista):CARDINAL;
  VAR
    i:CARDINAL;
    aux:TLista;
  BEGIN
    i:=0;
    aux:=lista;
    WHILE (aux<>NIL) DO
      INC(i);
      aux:=aux^.sig;
    END;
    RETURN(i);
  END LongitudLista;





  PROCEDURE InsertarLista(VAR lista:TLista; nom:TCadena;fila,prim,ult:CARDINAL);
  (* inserta un elemento al principio de la lista *)
  VAR
    datos:TPersona;
    nuevo:TLista;
  BEGIN
    NEW(nuevo);
    nuevo^.elem.nom:=nom;
    nuevo^.elem.fila:=fila;
    nuevo^.elem.prim:=prim;
    nuevo^.elem.ult:=ult;
    nuevo^.sig:=lista;
    lista:=nuevo;
  END InsertarLista;






  PROCEDURE BuscarAsiento(lista:TLista;fila,prim,ult:CARDINAL):BOOLEAN;
  (** devuelve TRUE  si el asiento est ocupado *)
  VAR
     ok:BOOLEAN;
     aux:TLista;
  BEGIN
     ok:=FALSE;
     aux:=lista;
     WHILE (aux<>NIL) AND NOT(ok) DO
        IF (aux^.elem.fila=fila) THEN
           IF (((aux^.elem.prim>=prim) AND (aux^.elem.ult>=ult))) OR (((aux^.elem.prim<=prim) AND (aux^.elem.ult<=ult))) OR ((aux^.elem.prim<=prim) AND (aux^.elem.ult>=ult)) THEN
                 ok:=TRUE;
           END;
        END;
        aux:=aux^.sig;
     END;
     RETURN(ok);
  END BuscarAsiento;





  PROCEDURE BuscarPersona(lista:TLista;nombre:TCadena):BOOLEAN;
  (* devuelve TRUE si la persona tiene una reserva *)
  VAR
    aux:TLista;
    ok:BOOLEAN;
  BEGIN
    aux:=lista;
    ok:=FALSE;
    WHILE (aux<>NIL) AND NOT(ok) DO
      IF CompararCadenas(aux^.elem.nom,nombre) THEN
         ok:=TRUE;
      END;
      aux:=aux^.sig;
    END;
    RETURN(ok);
  END BuscarPersona;





  PROCEDURE ImprimirLista(lista:TLista);
  (** Imprime la lista de reserva **)
  VAR
    aux:TLista;
  BEGIN
    aux:=lista;
    WHILE aux<>NIL DO
       WrStr("-Comprador: ");WrStr(aux^.elem.nom);WrLn;
       WrStr("-Fila: ");WrCard(aux^.elem.fila,0);WrLn;
       WrStr("-Butacas ");WrCard(aux^.elem.prim,2);WrStr(" a");WrCard(lista^.elem.ult,2);WrLn;
       aux:=aux^.sig;
       Pausa();
    END;
  END ImprimirLista;





  PROCEDURE EliminarPersona(VAR lista:TLista;nombre:TCadena);
  (** precondicion:el elemento est en la lista. ****)
  VAR
    ant,act:TLista;
  BEGIN
    act:=lista;
    ant:=NIL;
    WHILE (act<>NIL) AND (NOT(CompararCadenas(act^.elem.nom,nombre))) DO
       ant:=act;
       act:=act^.sig;
    END;
    IF ant=NIL  THEN
        lista:=lista^.sig;
    ELSE
      ant^.sig:=act^.sig;
    END;
    DISPOSE(act);
  END EliminarPersona;






  PROCEDURE DestruirLista(VAR lista:TLista);
  (* destruye la lista de reservas *)
  VAR
    aux:TLista;
  BEGIN
     WHILE lista<>NIL DO
        aux:=lista;
        lista:=lista^.sig;
        DISPOSE(aux);
     END;
  END DestruirLista;





  PROCEDURE GuardarLista(lista:TLista;nomfich:TCadena);
  (** Guarda la lista en un fichero que sabemos que existe **)
  VAR
     f:FIO.File;
     aux:TLista;
     BEGIN
       f:=FIO.Append(nomfich);
       aux:=lista;
       WHILE (aux<>NIL) DO
          FIO.WrCard(f,aux^.elem.fila,0);FIO.WrChar(f," ");
          FIO.WrCard(f,aux^.elem.prim,0);FIO.WrChar(f," ");
          FIO.WrCard(f,aux^.elem.ult,0);FIO.WrChar(f," ");
          FIO.WrStr(f,aux^.elem.nom);FIO.WrLn(f);
          aux:=aux^.sig;
       END;
       FIO.Close(f);
END GuardarLista;





(*************  Operaciones con el TAD TCine  *************************)


  PROCEDURE Crear():TCine;
  (* crea la estructura *)
  VAR
    i:CARDINAL;
    cine:TCine;
  BEGIN
    NEW(cine);
    FOR i:=1 TO NUMSALAS DO
      cine^[i].peli[1]:=CHR(0);
      cine^[i].fila:=0;
      cine^[i].butacas:=0;
      cine^[i].reserva:=NIL;
    END;
    RETURN(cine);
  END Crear;






  PROCEDURE DefinirPelicula(VAR cine:TCine;sala:CARDINAL;peli:TCadena;
                             filas,butacas:CARDINAL;VAR ok:BOOLEAN);
  (* inserta los datos de la pelicula de una determinada sala *)
  VAR
     datos:TDatosSala;
  BEGIN
    ok:=TRUE;
    IF (sala<=0) OR (sala>NUMSALAS) THEN
       ok:=FALSE;
    ELSE
       datos.peli:=peli;
       datos.fila:=filas;
       datos.butacas:=butacas;
       IF cine^[sala].peli[1]=CHR(0) THEN
           DestruirLista(cine^[sala].reserva);
       END;
       cine^[sala].peli:=peli;
       cine^[sala].fila:=filas;
       cine^[sala].butacas:=butacas;
    END;
   END DefinirPelicula;









  PROCEDURE Comprar(VAR cine:TCine;num:CARDINAL;nom:TCadena;
                    fila,fprim,fult:CARDINAL;VAR ok1:BOOLEAN;VAR ok2:BOOLEAN);
  (** reserva localidades a una persona **)
  (** ok1=FALSE si la sala no existe**)
  (** ok2=FALSE si los asientos estn ocupados **)
  BEGIN
    ok1:=TRUE;
    ok2:=TRUE;
    IF (num<=0) OR (num>NUMSALAS) THEN
        ok1:=FALSE;
    ELSIF (fila>cine^[num].fila) OR (cine^[num].butacas<fult) OR (cine^[num].butacas<fprim) THEN
       ok2:=FALSE;
    ELSE
        IF  BuscarAsiento(cine^[num].reserva,fila,fprim,fult) THEN
             ok2:=FALSE;
        ELSE
            InsertarLista(cine^[num].reserva,nom,fila,fprim,fult);
        END;
    END;
  END Comprar;







  PROCEDURE Cancelar(VAR cine:TCine;num:CARDINAL;nom:TCadena;VAR ok1:BOOLEAN;VAR ok2:BOOLEAN);
  (* anula la reserva hecha por una persona *)
  BEGIN
     ok1:=TRUE;
     ok2:=FALSE;
     IF (num>NUMSALAS) OR (num<=0) THEN
         ok1:=FALSE; (* la sala no existe *)
     ELSE
        IF NOT(BuscarPersona(cine^[num].reserva,nom)) THEN
           ok2:=FALSE;
        ELSE
           EliminarPersona(cine^[num].reserva,nom);
        END;
     END;
  END Cancelar;







  PROCEDURE ListarTodas(cine:TCine);
  (* Imprime por pantalla las localidades vendidas para cada sala *)
  VAR
    i:CARDINAL;
  BEGIN
    FOR i:=1 TO NUMSALAS DO
        WrStr("SALA ");WrCard(i,0);WrLn;WrLn;
        IF cine^[i].peli[1]=CHR(0) THEN
           WrStr("Esta sala no tiene asignada ninguna pelicula.");
        ELSE
           WrStr("-Titulo: ");WrStr(cine^[i].peli);WrLn;
           WrStr("-Numero de filas: ");WrCard(cine^[i].fila,0);WrLn;
           WrStr("-Numero de butacas por fila: ");WrCard(cine^[i].butacas,0);WrLn;WrLn;
           IF cine^[i].reserva<>NIL THEN
              ImprimirLista(cine^[i].reserva);
           END;
        END;
        Pausa();
        Clear;
     END;
   END ListarTodas;





  PROCEDURE Destruir(VAR cine:TCine);
  (* destruye la estructura *)
  VAR
    i:CARDINAL;
  BEGIN
    FOR i:=1 TO NUMSALAS DO
       DestruirLista(cine^[i].reserva);
    END;
    DISPOSE(cine);
  END Destruir;



(** FORMATO DEL FICHERO **)
(* numsala numfilas numbutacas pelicula*)
(* numreservas(longitudlista) *)
(* fila butacaprimera butacaultima nombrecomprador *)



  PROCEDURE GuardarCine(cine:TCine;nomfich:TCadena);
  VAR
     f:FIO.File;
     i:CARDINAL;
  BEGIN
     IF NOT(FIO.Exists(nomfich)) THEN
         f:=FIO.Create(nomfich);
         FIO.Close(f);
     END;
     f:=FIO.Open(nomfich);
     FOR i:=1 TO NUMSALAS DO
         IF cine^[i].peli[1]<>CHR(0) THEN
             FIO.WrCard(f,i,0);FIO.WrChar(f," ");
             FIO.WrCard(f,cine^[i].fila,0);FIO.WrChar(f," ");
             FIO.WrCard(f,cine^[i].butacas,0);FIO.WrChar(f," ");
             FIO.WrStr(f,cine^[i].peli);FIO.WrLn(f);
             FIO.WrCard(f,LongitudLista(cine^[i].reserva),0);FIO.WrLn(f);
             FIO.Close(f);
             GuardarLista(cine^[i].reserva,nomfich);
             f:=FIO.Append(nomfich)
         END;
     END;
     FIO.Close(f);
  END GuardarCine;





  PROCEDURE CargarCine(VAR cine:TCine;nomfich:TCadena;VAR ok:BOOLEAN);
  (* carga los datos de un fichero en el TAD TCine,destruyendo los que hubiese*)
  VAR
     f:FIO.File;
     i:CARDINAL;
     sala:TDatosSala;
     persona:TPersona;
     numsala,numres:CARDINAL;
     ok1:BOOLEAN;
  BEGIN
    Destruir(cine);
    IF FIO.Exists(nomfich) THEN
        ok:=TRUE;
        cine:=Crear();
        f:=FIO.Open(nomfich);
        numsala:=FIO.RdCard(f);
        WHILE NOT(FIO.EOF) DO
            sala.fila:=FIO.RdCard(f);
            sala.butacas:=FIO.RdCard(f);
            FIO.RdStr(f,sala.peli);
            DefinirPelicula(cine,numsala,sala.peli,sala.fila,sala.butacas,ok1);
            numres:=FIO.RdCard(f);
            FOR i:=1 TO numres DO
               persona.fila:=FIO.RdCard(f);
               persona.prim:=FIO.RdCard(f);
               persona.ult:=FIO.RdCard(f);
               FIO.RdStr(f,persona.nom);
               InsertarLista(cine^[numsala].reserva,persona.nom,persona.fila,persona.prim,persona.ult);
            END;
            numsala:=FIO.RdCard(f);
        END;
        FIO.Close(f);
    ELSE
       ok:=FALSE;
    END;
  END CargarCine;

END LibCine.



